#include "ngpc.h"

volatile u8 WD;
volatile u32 SMPPTR;
volatile u32 START_SAMPLE;
volatile u32 END_SAMPLE;

void __interrupt wavLoopTimer0(void)
{
__ASM(" cpb (_WD),0");
__ASM(" jr   nz,wav_loopend");
__ASM(" ldb (_WD),1");
__ASM(" push xhl");
__ASM(" push bc");
__ASM(" ld   xhl,(_SMPPTR)");
__ASM(" ld   b,(xhl+)");
__ASM(" ld   c,b");
__ASM(" ld   (0xa2),bc");
__ASM(" pop  bc");
__ASM(" cp   xhl,(_END_SAMPLE)");
__ASM(" jr   nz,wav_loopnotend");
__ASM(" ld   xhl,(_START_SAMPLE)");
__ASM("wav_loopnotend:");
__ASM(" ld   (_SMPPTR),xhl");
__ASM(" pop  xhl");
__ASM(" ldb  (_WD),0");
__ASM("wav_loopend:");
}

void __interrupt wavLoopTimer0Emu(void)
{
__ASM(" cpb (_WD),0");
__ASM(" jr   nz,wav_loopend_emu");
__ASM(" ldb (_WD),1");
__ASM(" push xhl");
__ASM(" push bc");
__ASM(" ld   xhl,(_SMPPTR)");
__ASM(" ld   bc,(xhl+)");
__ASM(" ld   (0xa2),bc");
__ASM(" pop  bc");
__ASM(" cp   xhl,(_END_SAMPLE)");
__ASM(" jr   nz,wav_loopnotend_emu");
__ASM(" ld   xhl,(_START_SAMPLE)");
__ASM("wav_loopnotend_emu:");
__ASM(" ld   (_SMPPTR),xhl");
__ASM(" pop  xhl");
__ASM(" ldb  (_WD),0");
__ASM("wav_loopend_emu:");
}

void __interrupt wavTimer0(void)
{
__ASM(" cpb  (_WD),0");
__ASM(" jr   nz,wav_end");
__ASM(" ldb  (_WD),1");
__ASM(" push xhl");
__ASM(" ld   xhl,(_SMPPTR)");
__ASM(" or   xhl,xhl");
__ASM(" jr   z,wav_out");
__ASM(" push bc");
__ASM(" ld   b,(xhl+)");
__ASM(" ld   c,b");
__ASM(" ld  (0xa2),bc");
__ASM(" pop  bc");
__ASM(" cp   xhl,(_END_SAMPLE)");
__ASM(" jr   nz,wav_notend");
__ASM(" xor  xhl,xhl");
__ASM("wav_notend:");
__ASM(" ld  (_SMPPTR),xhl");
__ASM("wav_out:");
__ASM(" pop  xhl");
__ASM(" ldb  (_WD),0");
__ASM("wav_end:");
}

void __interrupt wavTimer0Emu(void)
{
__ASM(" cpb  (_WD),0");
__ASM(" jr   nz,wav_end_emu");
__ASM(" ldb  (_WD),1");
__ASM(" push xhl");
__ASM(" ld   xhl,(_SMPPTR)");
__ASM(" or   xhl,xhl");
__ASM(" jr   z,wav_out_emu");
__ASM(" push bc");
__ASM(" ld   bc,(xhl+)");
__ASM(" ld  (0xa2),bc");
__ASM(" pop  bc");
__ASM(" cp   xhl,(_END_SAMPLE)");
__ASM(" jr   nz,wav_notend_emu");
__ASM(" xor  xhl,xhl");
__ASM("wav_notend_emu:");
__ASM(" ld  (_SMPPTR),xhl");
__ASM("wav_out_emu:");
__ASM(" pop  xhl");
__ASM(" ldb  (_WD),0");
__ASM("wav_end_emu:");
}

extern void __interrupt DummyFunction(void);
extern u8 hc_emu();

void wavStop()
{
__ASM(" di");
__ASM(" and (0x20),0xfe");
    TI0_INT=DummyFunction;
    SMPPTR=0;
    START_SAMPLE=0;
    END_SAMPLE=0;
__ASM(" ei");
}

void wavPlayLoop(u8 *smp)
{
    u32 length = *((u32*)(smp+40));
__ASM(" di");
__ASM(" andb (0x20),0xfe");
    WD = 0;
    SMPPTR=(u32)(smp+44);
    START_SAMPLE=SMPPTR;
    END_SAMPLE=SMPPTR+length;
    if (hc_emu())
    {
        END_SAMPLE&=0xfffffffe;
        TI0_INT=wavLoopTimer0Emu;
    }
    else
        TI0_INT=wavLoopTimer0;
__ASM(" ldb  (0x24),0x02");
    if(!hc_emu())
    {
    __ASM(" ldb rw3,4"); // VECT_INTLVSET
    __ASM(" ldb rb3,3");
    __ASM(" ldb rc3,2");
    __ASM(" swi 1");
    }
__ASM(" orb  (0x20),0x01");
__ASM(" ei");
}

void wavPlay(u8 *smp,u8 w)
{
    u32 length = *((u32*)(smp+40));
__ASM(" di");
__ASM(" andb (0x20),0xfe");
    WD=0;
    SMPPTR=(u32)(smp+44);
    START_SAMPLE=0;
    END_SAMPLE=SMPPTR+length;
    if (hc_emu())
    {
        END_SAMPLE&=0xfffffffe;
        TI0_INT=wavTimer0Emu;
    }
    else
        TI0_INT=wavTimer0;
__ASM(" ldb  (0x24),0x02");
__ASM(" ldb rw3,4"); // VECT_INTLVSET
__ASM(" ldb rb3,3");
__ASM(" ldb rc3,2");
__ASM(" swi 1");
__ASM(" orb  (0x20),0x01");
__ASM(" ei");
    if (!w)
     return;
    while (SMPPTR!=0)
    {
        __ASM("nop");
        __ASM("nop");
        __ASM("nop");
        __ASM("nop");
    }
    wavStop();
}

void wavCheck()
{
    if (END_SAMPLE != 0 && SMPPTR==0)
        wavStop();
}
